
#define UB 92.0


/* struttura dati per la soluzione parziale */
struct TBrenchStruct 
{
        int*   SequenceValue;           //seq: Soluzion parziale ovvero la sequenza dei nodi da visitare per raggiungere la soluzione parziale 
        int    Level;		            //liv:  livello
        double PartialValue;            //val:  costo della soluzione parziale
        int*   NotVisitedNodes;         //Nodi non visiati
		int*   NotVisitedNodesPerLowerBound;
        double LowerBound;              //lb :  lower bound
        struct TBrenchStruct * Next;    //rec:  puntatore all' elemento successivo della lista
} ;//rec;


typedef struct{
              unsigned int eval_nodes;
              unsigned int max_l_coda;
              unsigned int l_coda;
              unsigned int best_node;   // nodo in cui si e' trovata la soluzione migliore
              
              
              } TStat;



// Inizializzazione della struttura di brenching
/*
args:
  N = dimensione della matrice quadrata di ingresso;
  *tree = punatore all'albero di Brench;
  Stat = valorisi gnificativi per l'esecuzione.
*/ 
void Init_BrenchStruct(int N, TBrenchStruct **tree, TStat *Stat);

// Inizializzazione delle statistiche
/*
  args:
    stat = valori significativi per l'esecuzione. 

*/

void Init_Stat(TStat * stat);

// estrae il padre dall'albero di visita mettendolo in tree. Mette padre a NULL;
/*
  args:
    padre= nodo corrente;
    tree= punattore attuale all'albero;
    stat = valori significativi per l'esecuzione. 
*/
TBrenchStruct * RootExtract( TBrenchStruct ** tree);

// Dealloca la struttura puntata da padre 
void DeleteNode(TBrenchStruct ** node);



// Alloca figli in base alla matrice di ingresso.
TBrenchStruct * AllocSon(int N,TBrenchStruct*padre,int node);

void MakeSon(TBrenchStruct ** tree,TBrenchStruct *padre, int N, double ** DistanceMatrix, TBrenchStruct **best,long *nodicreati, double * ub,TBrenchStruct** last,int *MaxLung);

void Elabora_foglia(TBrenchStruct *tree,TBrenchStruct ** figlio,TBrenchStruct **best,double * ub);

void Sol_disp(TBrenchStruct* p,int N);

void Search(TBrenchStruct ** tree,TStat stat,double ** DistanceMatrix,int N,TBrenchStruct** best, long *nodicreati, double * ub,TBrenchStruct** last,int *MaxLung);

void Insert_best_first(TBrenchStruct **nodo,TBrenchStruct **tree);

void Insert_deep_first(TBrenchStruct **nodo,TBrenchStruct **tree);

void Insert_breath_first(TBrenchStruct **nodo,TBrenchStruct **tree,TBrenchStruct **last);


void RootExtract( TBrenchStruct ** tree,TBrenchStruct ** padre);

unsigned int Lunghezza_lista (TBrenchStruct* tree);

void PrintList(TBrenchStruct* tree);