#include <limits.h>
#define NITERATION 48
#define INIT_ITERATION 300
#define ALPHA_LIMIT 0.005
#define ALPHA 2.0
#define ALPHA_INIT 2.0
#define ROOT_LEVEL 1
#define MAX_PROBLEM 1


struct TIntArray
{
	int * Values;
	int size;
};

struct TDoubleArray
{
	float  * Values;
	int size;
};

struct TFixedCol
{
	int * Value;
	int * IsFixed;
};
/* struttura dati per la soluzione parziale */
struct TBrenchStruct 
{
        int						Level;					//livello
        float					PartialValue;			//costo della soluzione parziale
        struct	TIntArray 		CombinationList;		//lista di colonne a fissate 
		struct	TIntArray		ColNotInList;			//lista  di colonne non fissate 
		float					LowerBound;				//lower bound
		float					*CostoRidotto;			//costi
        struct	TBrenchStruct	*Next;					//puntatore all' elemento successivo della lista
		int						*RemaningOnePerRow;		//Vettore di booleani contenente le colonne eliminate fino a quel momento
		struct	TIntArray		RemainingRow;			//Vattore contente le colonne rimanenti
		struct	TFixedCol		FixedCol;				//vettore di bool a true se un colonna  stata fissata
		struct	TIntArray		IsCoveredRow;			//vettore di bool inidicante se na riga  coperta o meno
		int						CoveredRowNumber;		//numero di colonne coperte
		float					*penalties;

} ;

struct TCalcoloLB
{
	struct TDoubleArray		CostoRidotti;			//Array di costi ridotti
	struct TDoubleArray		SubGradienti;			//Array di sugradienti
	struct TDoubleArray		Penalties;				//Array di penalit lagrangiane
	struct TIntArray		ColsNotInSol;			//Array temporaneo contentente le colonne a zero
	struct TIntArray		LBSolutionTmpIndexList;	//Array temporaneo delle colone settate a zero
	struct TIntArray		LBSolutionTmpIndexList2;//Array temporaneo delle colone settate a zero
	struct TIntArray		TempColList;			//Lista delle colonne temporanee
	struct TIntArray		TempRowList;			//Lista dell righe temporanea
	struct TFixedCol		SensAnalFC;				//Struttura contente le  colonne fissate dall'analisi di sensitivit
	struct TIntArray		FixedRow;
};
struct TGlobalS 
{
        float	*ArrayCosti;			//Arrai dei cisri delle colone	           
        int		**PosUnoPerRow;         //Matrice di righe a 1
		int		*NumUnoPerRow;			//numero uni per riga
		int		**PosUnoPerCol;
		int		*NumUnoPerCol;
        int		**MatrixZeroOne;		//Matrice di zeri e uni
		int		NumCol;					//Numero colonnne
		int		NumRow;					//numero righe
		int		*colList;				//Colonne da visitare
		int		*rowList;				//lista righe
		
		struct TCalcoloLB LB;
} ;



// Inizializzazione della struttura di brenching
/*
args:
  N = dimensione della matrice quadrata di ingresso;
  *tree = punatore all'albero di Brench;
  Stat = valorisi gnificativi per l'esecuzione.
*/ 
void Init_BrenchStruct(int N,   struct  TBrenchStruct **tree);



void PrintDArr(float *p,int size);
// Dealloca la struttura puntata da padre 
void DeleteNode( struct  TBrenchStruct ** node);

 struct  TBrenchStruct * AllocSon( struct  TBrenchStruct*padre,int node,int coldel);

int MakeSon(  struct  TBrenchStruct ** tree, struct  TBrenchStruct *padre,  struct  TBrenchStruct **best, struct  TBrenchStruct ** last,int *MaxLung,int DelCol);

void Elabora_foglia( struct  TBrenchStruct *tree, struct  TBrenchStruct ** figlio, struct  TBrenchStruct **best,float  * ub );

void Sol_disp( struct  TBrenchStruct* p,int N);

void Search(  struct  TBrenchStruct ** tree, struct  TBrenchStruct** best,  struct  TBrenchStruct ** last,int *MaxLung);

void Insert_best_first( struct  TBrenchStruct **nodo, struct  TBrenchStruct **tree);

void Insert_deep_first( struct  TBrenchStruct **nodo, struct  TBrenchStruct **tree);

void Inser_breath_first(struct TBrenchStruct **nodo,  struct TBrenchStruct **last);

void RootExtract( struct TBrenchStruct ** tree,  struct  TBrenchStruct ** padre);

unsigned int Lunghezza_lista ( struct TBrenchStruct* tree);

void generateRows(int coldel,struct TBrenchStruct *p, struct TBrenchStruct *padre);

int generateCols(struct TBrenchStruct *p,struct TBrenchStruct *padre,int coldel, int fixedvalue);

void PrintList(struct TBrenchStruct* tree);

void PrintArr(int *p,int size);

int *ConvSol(int * a,int Dim,int * dimret);

int findCol( float  * CostoRidotto,int * DeletedCol,int NumCol);

int getCol(struct TBrenchStruct *padre);

void List2Arr(int * arr,int * list,int DimList);

int CanBeSolution(struct TBrenchStruct *p,int coldel);

int  CalcolaUpperBound(float *UpperBound,struct TBrenchStruct * p);

int IsCoveredRowf(int Row,struct TBrenchStruct *p);

void SensAnal(float Zlb,float Zub);