#include "../header/LagrangeBound.h"
#if !defined TREE_LIB_H
	
	#include "../header/TreeLib.h" 
	#define TREE_LIB_H

#endif

#if !defined LTST_LIB_H
	
	#include "../Header/ListLib.h" 
	#define SUB_LIB_H

#endif
extern int CalcolaUpper;
extern struct TGlobalS GS;
extern int nodicreati;
extern float Fix;
extern int Delete ;
extern float LBTMP;

int LagrangeLB (float  *UpperBoundValue,float  * LowerBoundValue,float   SommaPenalties,int *is_better)
{

//Index
int i,k,t;

//Valore dell'indice di cofficente riga minimo tra le righe coperte 
int MinIndex=0;

//Lower e upper bound temporaneo
float  UBTMP=0;

LBTMP=0;
//Azzero  le liste che utilizzar
GS.LB.ColsNotInSol.size=0;
GS.LB.LBSolutionTmpIndexList.size=0;
GS.LB.LBSolutionTmpIndexList2.size=0;


(*is_better)=FALSE;
//Per tutte le colonne i-esime
for(i=0;i<GS.LB.TempColList.size;++i)
{
	t=GS.LB.TempColList.Values[i];

	if(GS.LB.SensAnalFC.IsFixed[t])
		continue;

	/*//Caso in cui la colonna sia gi stata fissata dall'analisi di sensitivit
	if(GS.LB.SensAnalFC.IsFixed[t])
	{
		if(GS.LB.SensAnalFC.Value[t]==0)
		{
			LBTMP+=GS.LB.CostoRidotti.Values[t] ;
			AddElement(GS.LB.LBSolutionTmpIndexList.Values,&GS.LB.LBSolutionTmpIndexList.size,t,GS.LB.TempColList.size);
	
		}
		else
		{
			AddElement(GS.LB.ColsNotInSol.Values,&GS.LB.ColsNotInSol.size,t,GS.LB.TempColList.size);

		}

		continue;
	}*/

	//Inizializzo i-esimo CGrande per il calcolo del Lower Bound
	GS.LB.CostoRidotti.Values[t]=GS.ArrayCosti[t];
	
		for(k=0;k<GS.LB.TempRowList.size;++k)
		{
			if(GS.MatrixZeroOne[GS.LB.TempRowList.Values[k]][t]!=0)
				GS.LB.CostoRidotti.Values[t]-=GS.LB.Penalties.Values[GS.LB.TempRowList.Values[k]];
		}

		//Se Il CGrande i-esimo  minore di 0 allora l'iesima riga sar coperta
		if(GS.LB.CostoRidotti.Values[t]<=0)
		{
			LBTMP+=GS.LB.CostoRidotti.Values[t] ;
			AddElement(GS.LB.LBSolutionTmpIndexList.Values,&GS.LB.LBSolutionTmpIndexList.size,t,GS.LB.TempColList.size);
		}
		else
		{
			AddElement(GS.LB.ColsNotInSol.Values,&GS.LB.ColsNotInSol.size,t,GS.LB.TempColList.size);
		}

}
LBTMP+=SommaPenalties+Fix;


//Copio la soluzione del lower bound
memcpy(GS.LB.LBSolutionTmpIndexList2.Values,GS.LB.LBSolutionTmpIndexList.Values,sizeof(int) * GS.LB.LBSolutionTmpIndexList.size );

GS.LB.LBSolutionTmpIndexList2.size=GS.LB.LBSolutionTmpIndexList.size;

//Solo se trovo una soluzione migliorante calcolo l'upper bound 
if((LBTMP)>(*LowerBoundValue) )
{
	//Abilito il flag che mo dice ho trovato una soluzione migliore
	(*is_better)=TRUE;
	
	//Assegno la nuovo lower bound
	(*LowerBoundValue)=LBTMP;

	//INIZIO DEL CALCOLO DELL'UB
	




	
	for(i=0;i<GS.LB.TempRowList.size;++i)
	{
		t=GS.LB.TempRowList.Values[i];
		if(IsNotCoveredRow(t))
		{

			MinIndex=IndexMinCost(t);

		
			if(MinIndex<0)
			{
		
				printf("errore  in lagrange lb")	;
				Delete=TRUE;
				return FALSE;
				//getchar();
			}
		
		}
		
	}//fine for


	//Calcolo l'ub come somma dei costi corrisopondenti alle righe coperte
	for(i=0;i<(GS.LB.LBSolutionTmpIndexList2.size);++i)
	{
			UBTMP+=GS.ArrayCosti[GS.LB.LBSolutionTmpIndexList2.Values[i]];
	}
	UBTMP+=Fix;

	if(UBTMP<(*UpperBoundValue))
		(*UpperBoundValue)=UBTMP;
	
	
	SensAnal((*LowerBoundValue),(*UpperBoundValue));
}

return TRUE;

} 



int IndexMinCost( int IndexNotCoveredRow)
{
	int i,t,IndexMin=-1,IndexMinOriginal;
	float  help=9999999;
	
	for(i=0;i<GS.LB.ColsNotInSol.size;++i)
	{
		t=GS.LB.ColsNotInSol.Values[i];
		if(GS.MatrixZeroOne[IndexNotCoveredRow][t]==1 )
		{
			if(GS.ArrayCosti[t]<help)
			{
				help=GS.ArrayCosti[t];
				IndexMinOriginal=t;
				IndexMin=i;
			}
		}
	}
	if(IndexMin==-1)
		return IndexMin;

	
	//Elimino l'indice delle colonne non in soluzione
	DeleteElement(GS.LB.ColsNotInSol.Values,&GS.LB.ColsNotInSol.size,IndexMin);

	//Lo aggiungo all'insieme delle colonne di soluzione
	AddElement(GS.LB.LBSolutionTmpIndexList2.Values,&(GS.LB.LBSolutionTmpIndexList2.size),IndexMinOriginal,GS.NumCol);
	
	return IndexMin;

}



void PrintArray(int *Array,int Dim)
{
    int i=0;
	printf("\n");
	for(i=0;i<Dim; i++)
	{
	  printf("%d\t",Array[i]);
	}
}


int IsNotCoveredRow(int Row)
{
int i;
float tmp=0;
if(GS.NumUnoPerRow[Row]==0)
	return FALSE;

for(i=0;i<GS.LB.LBSolutionTmpIndexList2.size;++i)
{
	tmp+=GS.MatrixZeroOne[Row][GS.LB.LBSolutionTmpIndexList2.Values[i]];
	if(tmp>0)
		return FALSE;
}

return TRUE;

}




void SensAnal(float Zlb,float Zub)
{
	int j,i,t,k;
	
	
		
	
	for(i=0;i<GS.LB.ColsNotInSol.size;++i)
	{
		t=GS.LB.ColsNotInSol.Values[i];

		
		if((Zlb+GS.LB.CostoRidotti.Values[t])>=Zub && !GS.LB.SensAnalFC.IsFixed[t])
		{
			
		
			GS.LB.SensAnalFC.IsFixed[t]=TRUE;
			GS.LB.SensAnalFC.Value[t]=0;
		
		
		}
	}

	
	for(i=0;i<GS.LB.LBSolutionTmpIndexList.size;++i)
	{
		
		t=GS.LB.LBSolutionTmpIndexList.Values[i];

		if((GS.LB.CostoRidotti.Values[t]-Zlb)>=Zub && !GS.LB.SensAnalFC.IsFixed[t])
		{
			GS.LB.SensAnalFC.IsFixed[t]=TRUE;
			GS.LB.SensAnalFC.Value[t]=1;
			Fix+=GS.ArrayCosti[t];


			for(j=(GS.LB.TempRowList.size-1);j>-1;--j)
			{
				k=GS.LB.TempRowList.Values[j];
				
					if(GS.MatrixZeroOne[k][t]==1 && !GS.LB.FixedRow.Values[k])
					{
						GS.LB.FixedRow.Values[k]=TRUE;
						DeleteElement(GS.LB.TempRowList.Values,&GS.LB.TempRowList.size,j);
					}
			}
		
		
		}
	}
	
}

