


#if !defined TREE_LIB_H
	
	#include "../Header/TreeLib.h" 
	#define TREE_LIB_H

#endif


#if !defined SUB_LIB_H
	
	#include "../Header/SubGradient.h" 
	#define SUB_LIB_H

#endif

#if !defined LTST_LIB_H
	
	#include "../Header/ListLib.h" 
	#define SUB_LIB_H

#endif


#include "string.h"
#include <stdlib.h>
#include <stdio.h>

extern struct TGlobalS GS;
extern float  ub;
extern int nodicreati;
extern int Allowable;
extern int Delete;



int  CalcolaUpperBound(float *UpperBound,struct TBrenchStruct * p)
{
int i;
	
	int MinIndex;
	
	
	(*UpperBound)=0;

	//Copio le coolonne che non sono in soluzione
	memcpy(GS.LB.ColsNotInSol.Values,p->ColNotInList.Values,sizeof(int)* GS.NumCol);
	GS.LB.ColsNotInSol.size=p->ColNotInList.size;

	
	//Copio la soluzione nella mia lista temporanea
	memcpy(GS.LB.LBSolutionTmpIndexList2.Values,p->CombinationList.Values,sizeof(int) * p->CombinationList.size );

	GS.LB.LBSolutionTmpIndexList2.size=p->CombinationList.size;
	
	for(i=0;i<GS.NumRow;++i)
	{
		if(IsNotCoveredRow(GS.rowList[i]))
		{
			
			MinIndex=IndexMinCost(GS.rowList[i]);
					
			if(MinIndex<0)
			{
				
				printf("Solution non bouna sono in calcola upper bound");
				
				return TRUE;
			}

		


		}//fine if
	}//fine for
	
	//Calcolo l'ub come somma dei costi corrisopondenti alle righe coperte
	for(i=0;i<(GS.LB.LBSolutionTmpIndexList2.size);++i)
	{
			(*UpperBound)+=GS.ArrayCosti[GS.LB.LBSolutionTmpIndexList2.Values[i]];
	}
	return FALSE;
}

void Init_BrenchStruct(int N,  struct TBrenchStruct **tree)
{
	int i=0;
	(*tree) = (  struct  TBrenchStruct *)malloc(sizeof(  struct  TBrenchStruct));
	(*tree)->Level=ROOT_LEVEL;
	(*tree)->PartialValue=0.0;
	(*tree)->LowerBound=0.0;
	
	//Init costi ridotti
	(*tree)->CostoRidotto=(float *)malloc(sizeof(float )*GS.NumCol);

	//Righe in lista
	(*tree)->CombinationList.Values=(int*)malloc(sizeof(int)*GS.NumCol);
	(*tree)->CombinationList.size=0;

	//Colonne non in lista 
	(*tree)->ColNotInList.Values=(int*)malloc(sizeof(int)*GS.NumCol);
	(*tree)->ColNotInList.size=N;
	(*tree)->RemaningOnePerRow=(int*)malloc(sizeof(int)*GS.NumRow);

	//Inizializzo le colonne fissate
	(*tree)->FixedCol.IsFixed=(int *)malloc(sizeof(int)*GS.NumCol);
	(*tree)->FixedCol.Value=(int *)malloc(sizeof(int)*GS.NumCol);
	

	//spazio penalties
	(*tree)->penalties=(float*)malloc(sizeof(float)*GS.NumRow);

	//Creo spazioe per le righe eliminate
	(*tree)->RemainingRow.Values=(int *)malloc(sizeof(int)* GS.NumRow);
	(*tree)->RemainingRow.size=GS.NumRow;

	//Creo spazio per linee coperte
	(*tree)->IsCoveredRow.Values=(int *)malloc(sizeof(int)* GS.NumRow);
	(*tree)->IsCoveredRow.size=GS.NumRow;
	(*tree)->CoveredRowNumber=0;

	//Copio dalla struttura globale il numero uni per riga
	memcpy((*tree)->RemaningOnePerRow,GS.NumUnoPerRow,sizeof(int)*GS.NumRow);

	//Inizializzo l'array delle colonne eliminate	
	for(i=0;i<GS.NumCol;++i)
	{
		(*tree)->ColNotInList.Values[i]=i;
		(*tree)->FixedCol.IsFixed[i]=FALSE;
		
	}
	

	//Inizializzo le colonne rimanenti per il nodo
	for(i=0;i<GS.NumRow;++i)
	{
		(*tree)->RemainingRow.Values[i]=i;
		(*tree)->IsCoveredRow.Values[i]=FALSE;
	}
	(*tree)->Next=NULL;

 }



void RootExtract(struct TBrenchStruct ** tree,struct TBrenchStruct ** padre)
{
	(*padre) = (*tree);
	(*tree) = (*padre)->Next;
	(*padre)->Next = NULL;
}




void DeleteNode( struct  TBrenchStruct ** node)
{
	free((*node)->CostoRidotto);
	free((*node)->CombinationList.Values);
	free((*node)->ColNotInList.Values);
	free((*node)->RemaningOnePerRow);
	free((*node)->FixedCol.IsFixed);
	free((*node)->FixedCol.Value);
	free((*node)->penalties);
	free((*node)->RemainingRow.Values);
	free((*node)->IsCoveredRow.Values);
	free((*node));
}
//Alloca la strittura per contenere i dati del figlio
struct  TBrenchStruct * AllocSon(struct  TBrenchStruct*padre,int node,int coldel)
{
     struct  TBrenchStruct * p;
	 
	
	//alloco spazio per figlio
    p= ( struct  TBrenchStruct *) malloc (sizeof( struct  TBrenchStruct));
	p->PartialValue=0;
	p->LowerBound=0;
	p->Next=NULL;

	
	//alloco il costo ridotto dell'iesimo nodo
	p->CostoRidotto=(float *)malloc(sizeof(float)*GS.NumCol);
	
	//Alloco le colonne non in soluzione
	p->ColNotInList.Values=(int*)malloc(GS.NumCol*sizeof(int));
	
	//Alloco le la lista delle colonne in soluzione
	p->CombinationList.Values=(int*)malloc(GS.NumCol*sizeof(int));
	p->CombinationList.size=0;
	p->ColNotInList.size=0;

	//Alloco spazio setto e tramando le colonne fissate
	p->FixedCol.IsFixed=(int *)malloc(sizeof(int)*GS.NumCol);
	memcpy(p->FixedCol.IsFixed,padre->FixedCol.IsFixed,sizeof(int)*GS.NumCol);
	p->FixedCol.Value=(int*)malloc(sizeof(int)* GS.NumCol);
	memcpy(p->FixedCol.Value,padre->FixedCol.Value,sizeof(int)*GS.NumCol);
	p->FixedCol.Value[coldel]=node;

	//tramando aia figli le colnne eliminate e la combinazione
	memcpy(p->CombinationList.Values,padre->CombinationList.Values,padre->CombinationList.size*sizeof(int));
	p->CombinationList.size=padre->CombinationList.size;
	
	//tramando ai figli le righe rimanenti
	p->RemainingRow.Values=(int * )malloc(sizeof(int)*padre->RemainingRow.size);
	//memcpy(p->RemainingRow.Values,padre->RemainingRow.Values,padre->RemainingRow.size);
	//p->RemainingRow.size=padre->RemainingRow.size;


	//tramando le linee coperte
	p->IsCoveredRow.Values=(int *)malloc(sizeof(int)*GS.NumRow);
	p->IsCoveredRow.size=GS.NumRow;
	memcpy(p->IsCoveredRow.Values,padre->IsCoveredRow.Values,sizeof(padre->IsCoveredRow.Values));
	p->CoveredRowNumber=padre->CoveredRowNumber;



	//tramando i contatori di uno per riga
	(p)->RemaningOnePerRow=(int*)malloc(sizeof(int)*GS.NumRow);
	memcpy(p->RemaningOnePerRow,padre->RemaningOnePerRow,sizeof(int)*GS.NumRow);
	p->RemainingRow.size=padre->RemainingRow.size;


	//alloco spazio per i penalties
	p->penalties=(float *)malloc(sizeof(float)*GS.LB.Penalties.size);
	

	//Incremento il livello
    p->Level=padre->Level+ 1;

  return(p);
}


void Search(  struct  TBrenchStruct ** tree , struct  TBrenchStruct** best, struct  TBrenchStruct ** last,int *MaxLung)
{
	struct  TBrenchStruct *padre=NULL;
	struct  TBrenchStruct *tmp=NULL;
	int i=0;
	int coldel;
	int Continua;
	
  while ((*tree) != NULL)
  {		
		RootExtract(&(*tree),&padre);
		
	
		//genero una colonna da eliminare
		coldel=getCol(padre);

		//Generazione dei figli
		Continua= MakeSon(&(*tree),padre,&(*best),&(*last),&(*MaxLung),coldel);
		
		//elimino il nodo visitato
		DeleteNode(&padre);
		
		if(!Continua)
			break;
  }

}


int  MakeSon(  struct  TBrenchStruct ** tree, struct  TBrenchStruct *padre,  struct  TBrenchStruct **best, struct  TBrenchStruct ** last,int *MaxLung,int DelCol)
{
    struct  TBrenchStruct * figlio;
    int i=0,j=0,tmp_lung=0,is_reached=FALSE;
	float  UbTmp=9999999,LB=0.0;
	
	
	


	for(i=1;i>-1;i--)
    {
		Allowable=FALSE;

		//Alloco spazio in memoria per il figlio
		figlio = AllocSon(padre,i,DelCol);
		
		//Se fisso a uno potrò eliminare righe
		if(i==1)
		{
			//genero le righe
			generateRows(DelCol,figlio,padre);	
		}
		else
		{
			memcpy(GS.LB.TempRowList.Values,padre->RemainingRow.Values,sizeof(int)*padre->RemainingRow.size);
			GS.LB.TempRowList.size=padre->RemainingRow.size;
			memcpy(figlio->RemainingRow.Values,padre->RemainingRow.Values,sizeof(int)*padre->RemainingRow.size);
			figlio->RemainingRow.size=padre->RemainingRow.size;
		}
		//genero le colonne
		if(!generateCols(figlio,padre,DelCol,i))
		{
			continue;
		}

		
		//altrimenti posso chiamare can be solution
	/*	else
		{
			if(!CanBeSolution(figlio,DelCol))
			{
				DeleteNode(&figlio);
				printf("elimino nodo non ammmissibile");
				continue;
			}
		}*/

		

		/*printf("\nfisso a %d\ la colonna %d",i,DelCol);
		printf("\nLe colonne  fissate sono \n");
		PrintArray(figlio->CombinationList.Values,figlio->CombinationList.size);		
		printf("\n");
		for(j=0;j<figlio->CombinationList.size;++j)
		{
			printf("%d\t",figlio->FixedCol.Value[figlio->CombinationList.Values[j]]);
		}
		printf("\nLe colonne sono:\n");
		PrintArray(GS.LB.TempColList.Values,GS.LB.TempColList.size);
		printf("\nLe righe sono:\n");
		PrintArray(GS.LB.TempRowList.Values,GS.LB.TempRowList.size);
		getchar();
		*/
		
		
	
		//Eseguo il subgradiente sul nodo e Setto lower bound
		figlio->LowerBound=NodeSubGradientLoop(i,figlio,padre,NITERATION,ALPHA,&is_reached) + figlio->PartialValue;
		
		if(Delete)
		{
			DeleteNode(&figlio);
			continue;
		}


		//Copio i costi ridotti nel nodo iesimo
		memcpy(figlio->CostoRidotto,GS.LB.CostoRidotti.Values,sizeof(float )*GS.LB.CostoRidotti.size);

		//copio i penalties
		memcpy(figlio->penalties,GS.LB.Penalties.Values,GS.LB.Penalties.size*sizeof(float ));
		
		
	


		
		
			
	/*	printf("\nUpper bound=%f",ub);
		printf("\nfiglio->PartialValue=%f",figlio->PartialValue);
		printf("\nLower bound=%f",figlio->LowerBound);
	*/	//getchar();
		//printf("\nLa soluzione è\n");
		//PrintArray(figlio->CombinationList.Values,figlio->CombinationList.size);
		//printf("\nFiglio level=%d\n",figlio->Level);
	

		(++nodicreati);
		
		/*printf("\nnodi %d",nodicreati);*/


		if( figlio->LowerBound<=ub && figlio->Level<=(GS.NumCol+1) && figlio->PartialValue<=ub )
		{
			//Decido se aggiungere o nodo un nodo alla lista
			if(Allowable)
			{
				if(figlio->PartialValue<ub)
					ub=figlio->PartialValue;
					
				
				
				//La soluzione è stata trovata blocco il ciclo
				if(ub==figlio->LowerBound )
				{
					Elabora_foglia((*tree),&figlio,&(*best),&ub);
					return FALSE;
				}
				else
				{
					Elabora_foglia((*tree),&figlio,&(*best),&ub);
				}

			}
			else	
			{
				//inserisce il figlio nella lista dei nodi aperti
				Insert_best_first(&figlio,&(*tree));
				tmp_lung=Lunghezza_lista(*tree);	
					//Aggiorno la lunghezza massima della coda
					if(tmp_lung >(*MaxLung))
						(*MaxLung)=tmp_lung  ;
			}
		}
		else
		{
			
			DeleteNode(&figlio);
					
		}
		

	

		
	
	
       }//End for
	



	return TRUE;

}

void Elabora_foglia( struct  TBrenchStruct *tree, struct  TBrenchStruct ** figlio, struct  TBrenchStruct **best,float  * ub )
{
	

  if ((*best)== NULL  )
  {
		(*best) = (*figlio);  
		(*figlio)=NULL;	
  }
	else 
	{
		if((*best)->PartialValue > (*figlio)->PartialValue )
		{
			DeleteNode(&(*best));
			*best = *figlio;
			*figlio=NULL;
		}
		else
			DeleteNode(&(*figlio));

	}
}
void  Insert_best_first(struct TBrenchStruct **nodo,struct TBrenchStruct **tree)
//inserimento ordinato in ordine decrescente rispetto al lower bound 
{
	
	
	//Rappresenta il nodo sucessivo
struct	TBrenchStruct* temp_pointer_succ=NULL;

	//Rappresenta i nodo precedente
struct	TBrenchStruct* temp_pointer_prec = (*tree);
	
	//Lista vuota
	if(temp_pointer_prec==NULL)
	{
		//inserimento i testa
		 (*nodo)->Next = (*tree);
		 (*tree) = (*nodo);  
		return;
	}

	
	//Controllo che il precedente non punti NULL
	//in modo da prendere il successivo 
	if (temp_pointer_prec != NULL)
	{
		//Pendo il successivo
		temp_pointer_succ =  temp_pointer_prec->Next;
	}
 

	
	//controllo se il nodo sia da inserire in testa
	if((*nodo)->LowerBound >= temp_pointer_prec->LowerBound)
	{
		//inserimento i testa
		(*nodo)->Next = (*tree);
		(*tree) = (*nodo); 
		return;
	}
	else
	{	
		//Se esiste solo un nodo allora
		if(temp_pointer_succ==NULL)
		{
			//Inserimeneto in coda
			temp_pointer_prec->Next=(*nodo);
			return;
		}
	}
	
	
	
	//Ciclo per l'inserimento del nodo nella lista
	while(TRUE)
	{
		//Se il nodo da inserire è minore del precedente e  maggiore o uguale del nodo da inserire
		if((*nodo)->LowerBound < temp_pointer_prec->LowerBound && (*nodo)->LowerBound >= temp_pointer_succ->LowerBound)
		{
			temp_pointer_prec->Next=(*nodo);
			(*nodo)->Next=temp_pointer_succ;
			return;
		}
		
		//Pendo il successivo
		temp_pointer_prec=temp_pointer_prec->Next;
		
		//Se è possibile continuo a scorere la lista 
		if(temp_pointer_prec->Next!=NULL)
		{
			temp_pointer_succ =temp_pointer_prec->Next;
		}
		//Altrimenti inserisco il nodo alla fine 
		else
		{
			temp_pointer_prec->Next=(*nodo);
			return;
		}
	}

  
}


void Insert_deep_first( struct  TBrenchStruct **nodo, struct  TBrenchStruct **tree)
{
	(*nodo)->Next = (*tree);
	(*tree) = (*nodo);  // inserimento in testa
}


void Insert_breath_first( struct  TBrenchStruct **nodo, struct  TBrenchStruct **last)
{
	(*last)->Next=(*nodo);
	(*nodo)=(*last);
}



void Sol_disp( struct  TBrenchStruct* p,int N)
{

  int j=0;
 
  printf("\nIl livello e' %d \n", p->Level) ;
  printf("Il costo della soluzione e' %f \n", p->PartialValue) ;

  printf("\n Combination vale:\n");
  for(j=0;j<p->CombinationList.size;++j)
	  printf("%d\t",p->CombinationList.Values[j]);

  
}

void generateRows(int coldel,struct TBrenchStruct *p, struct TBrenchStruct *padre)
{
	int i,t;
	p->RemainingRow.size=0;

	//Elimino tutte le righe che copre colonna eliminata
	for(i=0;i<padre->RemainingRow.size;++i)
	{	
		t=padre->RemainingRow.Values[i];
		if(IsCoveredRowf(t,p) && !p->IsCoveredRow.Values[t])
		{
			//controllo se era già stata coperta in un livello precedente
			//in caso ocntrario aggiorno il contatore delle colonee coperte
			if(p->IsCoveredRow.Values[t])
				p->CoveredRowNumber++;
			
			p->IsCoveredRow.Values[t]=TRUE;
		}

		if(GS.MatrixZeroOne[t][coldel]==0)
		{
			AddElement(p->RemainingRow.Values,&p->RemainingRow.size,t,GS.NumRow);
		
		}
	
	}
	
	
	GS.LB.TempRowList.size=p->RemainingRow.size;
	memcpy(GS.LB.TempRowList.Values,p->RemainingRow.Values,sizeof(int)*p->RemainingRow.size);
	//se le colonne sono a zero la soluzione è ammissibile
	if(p->RemainingRow.size==0)
		Allowable=TRUE;
	
}

int generateCols(struct TBrenchStruct *p,struct TBrenchStruct *padre,int coldel, int fixedvalue)
{
	int i,t,j;
	
	// è true se la colonna corrente deve essere fissata zero
	int ColFixedToZero;
	p->ColNotInList.size=0;


	p->PartialValue=padre->PartialValue;
	
	
	//ciclo sulle colonne inb soluzione
	for(i=0;i<padre->ColNotInList.size;++i)
	{
		
		ColFixedToZero=TRUE;

		//prendo la colonna dal padre
		t=padre->ColNotInList.Values[i];

		if(!p->FixedCol.IsFixed[t])
		{
			//fisso la colonna da fissare per l'algoritmo di brenchig
			if(t==coldel)
			{
				//aggoungo alla lista delle colonne fissate
				AddElement(p->CombinationList.Values,&p->CombinationList.size,t,GS.NumCol);
				p->FixedCol.IsFixed[t]=TRUE;
				p->FixedCol.Value[t]=fixedvalue;
				
				if(fixedvalue==0)
				{
					if(!CanBeSolution(p,coldel))
					{
						DeleteNode(&p);
						printf("elimino nodo non ammmissibile sono in gnerate cols");
						return FALSE;
						break;
					}
				}
				else
				{
					//La colonna è fissata uno aggiungo il valore al valore oarziale del nodo corremte
					p->PartialValue+=GS.ArrayCosti[t];
				}
					continue;
			}

			//Attivo il pre processing per le colonne
			
			//Scopro se un colonna copre solo righe già coperte
			for(j=0;j<p->RemainingRow.size;++j)
			{
				if(GS.MatrixZeroOne[p->RemainingRow.Values[j]][t]==1)
				{
					ColFixedToZero=FALSE;
					break;
				}
			}
			//fine ricerca se una colonna copre righe già coperte

			//Se la colonna deve essere fissata a zero
			if(ColFixedToZero)
			{
				//fisso la colonna a zero
				p->FixedCol.IsFixed[t]=TRUE;
				p->FixedCol.Value[t]=0;
					
				//aggiorno la lista delle colonne non lista
				AddElement(p->CombinationList.Values,&p->CombinationList.size,t,GS.NumCol);
				
				//aggiorno il valore della sluzione parziale
				


				//aggiorno o contatori di uno per riga
				if(!CanBeSolution(p,t))
				{
					DeleteNode(&p);
					printf("elimino nodo non ammmissibile sono in generatecols");
					return FALSE;
					break;
				}
				
				
			}
			else
			{

				//aggiorno la lista delle colonne non lista
				AddElement(p->ColNotInList.Values,&p->ColNotInList.size,t,GS.NumCol);

			
			}
		}


	}
		memcpy(GS.LB.TempColList.Values,p->ColNotInList.Values,sizeof(int)*(p->ColNotInList.size));
		GS.LB.TempColList.size=p->ColNotInList.size;

		return TRUE;

}


unsigned int Lunghezza_lista ( struct  TBrenchStruct* tree)
{
   struct  TBrenchStruct* tmp = tree;
  unsigned int counter = 0;
  while (tmp != NULL)
  {
    ++counter;
    tmp = tmp->Next;
	
  }
  return counter;
}

void PrintList( struct  TBrenchStruct* tree)
{
	 struct  TBrenchStruct* tmp = tree;
	printf("\n");
	while (tmp != NULL)
	{
		printf("%f\t",tmp->PartialValue);
		
		tmp = tmp->Next; 
	}

}

void PrintArr(int *p,int size)
{
	int i;
	for(i=0;i<size;++i)
	{
		printf("%d\t",p[i]);
	}
}
void PrintDArr(float *p,int size)
{
	int i;
	for(i=0;i<size;++i)
	{
		printf("%f\t",p[i]);
	}
}


int *ConvSol(int * a,int Dim,int * dimret)
{
	int i,cursor=0;
	int *array =malloc(sizeof(int) * Dim);

	for(i=0;i<Dim;++i)
	{
		if(a[i]==1)
		{
			array[cursor]=i;
			cursor++;
		}
	}
	(*dimret)=cursor;
	return array;
}
void List2Arr(int * arr,int * list,int DimList)
{
	int i;
	for(i=0;i<DimList;++i)
	{
		arr[list[i]]=1;
	}
}



int CanBeSolution(struct TBrenchStruct *p,int coldel)
{	
	int i;

			for(i=0;i<GS.NumUnoPerCol[coldel];++i)
			{

				p->RemaningOnePerRow[GS.PosUnoPerCol[coldel][i]]--;
				
				//Se rimane un solo uno potrò fissare la colonna a 1
				if(p->RemaningOnePerRow[GS.PosUnoPerCol[coldel][i]]==1 && !p->FixedCol.IsFixed[coldel])
				{
					p->FixedCol.IsFixed[coldel]=TRUE;
					p->FixedCol.Value[coldel]=1;
					p->PartialValue+=GS.ArrayCosti[coldel];
					//aggiorno la lista delle colonne non lista
					AddElement(p->CombinationList.Values,&p->CombinationList.size,coldel,GS.NumCol);
					
					if(!(p->IsCoveredRow.Values[GS.PosUnoPerCol[coldel][i]]))
					{
						//la righa sarà una riga coperta quindi aggiornerò le strutture riguardanti le righe
						p->IsCoveredRow.Values[GS.PosUnoPerCol[coldel][i]]=TRUE;
						p->CoveredRowNumber++;
					}
					
					

				}

				if(p->RemaningOnePerRow[GS.PosUnoPerCol[coldel][i]]<=0)
					return FALSE;
			}
	
	return TRUE;
}

int findCol( float  * CostoRidotto,int * DeletedCol,int NumCol)
{
int i;
float  tmp=99999999;
int IndexCol=0;


	for(i=0;i<NumCol;++i)
	{
		if(CostoRidotto[i]<tmp && !DeletedCol[i])
		{
			IndexCol=i;
			tmp=CostoRidotto[i];
		}
		
	}


return IndexCol;
}

int getCol(struct TBrenchStruct *padre)
{
int i,t,IndexCol=0;


float tmp=99999999;
	for(i=0;i<GS.NumCol;++i)
	{
		
		if(padre->CostoRidotto[i]<tmp && !padre->FixedCol.IsFixed[i])
		{
			IndexCol=i;
			tmp=padre->CostoRidotto[i];
		}
		
	}

	return IndexCol;

}

int IsCoveredRowf(int Row,struct TBrenchStruct *p)
{
int i,t;
float tmp=0;
if(GS.NumUnoPerRow[Row]==0)
	return TRUE;

for(i=0;i<p->CombinationList.size;++i)
{
	t=p->CombinationList.Values[i];
	
	if(p->FixedCol.Value[t]==1)
		tmp+=GS.MatrixZeroOne[Row][t];

	if(tmp>0)
		return TRUE;
}

return FALSE;
}