#include <string.h>
#include <time.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
 #include <windows.h>
 #include <winbase.h>





#if !defined TREE_LIB_H
	
	#include "../header/TreeLib.h" 
	#define TREE_LIB_H

#endif

#if !defined SUB_H
	
	#include "../header/SubGradient.h" 
	#define SUB_H

#endif


#define NUM_FILE 5;




//legge le strurre dati dal file di ingresso
void Leggi( char *path);

void Preprocessing(struct TBrenchStruct *node);

void ControllaDati();
void Algoritmo(char ** nomefile);
void RandomGen(int ncol, int nrow,int maxcost);
void DeleteGS();
void provatempo();
struct TGlobalS GS;

//Upperbound
float  ub=9999999;
int nodicreati;
float Fix;
int Allowable;
int Delete;
float LBTMP=0;

int main(int argc, char *argv[])
{


	char ** files;
	//provatempo();
	//getchar();
	
	files=(char**)malloc(sizeof (char )*5);
	files[0]="scp41.txt";
	files[1]="scp42.txt";
	files[2]="scp43.txt";
	files[3]="scp44.txt";
	files[4]="scp45.txt";

	
	Algoritmo(files);


}
void Algoritmo(char ** nomefile)
{
	struct TBrenchStruct *BrenchTree;
	struct TBrenchStruct *best=NULL;
	double duration=0;
	//struttura contente la struttura dati globale
	
	FILE *stream;

  
	
	//colonne eliminate
	int *DeletedColumns=NULL; 
	
	
	
	//Contatore massima lunghezza coda
	int MaxLung=0;

	//indici
	int i=0;

	//tempo iniziale e finale
	LARGE_INTEGER start_ticks, end_ticks, cputime,ticksPerSecond;
	struct TBrenchStruct * last=NULL;
	
	//True se ho ottenuto l'ottimo
	int is_optimal_reached=FALSE;
	
	//contatore nodi creati
	 nodicreati=0;
	if (!QueryPerformanceFrequency(&ticksPerSecond))
		printf("\tno go QueryPerformance not present");
		printf ("\tfreq test:   %I64Ld ticks/sec\n",ticksPerSecond    );
	 /* apre lo stream del file */
	  stream = fopen("out.txt", "w");

	 for(i=0;i<5;++i)
	 {
		 best=NULL;
		//Leggo la struttura dati
		Leggi(nomefile[i]);
	
	
	
	
	
		


	
		//RandomGen(10,6,90);
	

	
		//	ControllaDati();
		
		//Inizializzo la struttura di brench
		Init_BrenchStruct(GS.NumCol,&BrenchTree);

		//Avvio il timer
		QueryPerformanceCounter(&start_ticks); 


		//Inizializzo il puntatore all'ultimo elemento della lista per l'iserimeno in fondonalla lista
		last=BrenchTree;
		
		//Eseguo il subrgadiente al nodo radice
		BrenchTree->LowerBound=SubGradientLoop(BrenchTree,INIT_ITERATION,ALPHA_INIT,&is_optimal_reached);
		
		//Copia dei costi ridotti
		memcpy(BrenchTree->CostoRidotto,GS.LB.CostoRidotti.Values,sizeof(float )*GS.LB.CostoRidotti.size);
		memcpy(BrenchTree->penalties,GS.LB.Penalties.Values,GS.LB.Penalties.size*sizeof(float ));
		
		//ricecerca b&b
		if(!is_optimal_reached)
		{
			Search(&BrenchTree,&best,&last,&MaxLung);
		}
		else
		{
			
			best=BrenchTree;
			best->PartialValue=ub;
		}

		//arresto iltimer
		QueryPerformanceCounter(&end_ticks); 
		cputime.QuadPart = end_ticks.QuadPart- start_ticks.QuadPart;

		if(best!=NULL)
		{
			printf("\nLa soluzione  stata trovata\n");
			Sol_disp(best,GS.NumCol);
		}
		else
		{
			printf("\nLa soluzione non   stata trovata\n");
		}

	
		duration=((float)cputime.QuadPart/(float)ticksPerSecond.QuadPart);
		fprintf(stream,"\n \t %d \t %d \t %f",nodicreati,MaxLung, duration);
		printf("\n \t %d \t %d \t %f",nodicreati,MaxLung,duration);
		getchar();
		DeleteGS();
		//getchar();
	 }
	
	fflush(stream);
	fclose(stream);
	getchar();
	return ;
}
void Leggi( char *path)
{
//puntatore a file
FILE *file=NULL;


//indice
int i=0,j=0;
int tmp;


//Numero di uni su di una riga
int NumeroUni=0;

//Posizione uno
int PosUno=0;

file=fopen(path, "r");


//Controllo esistenza file
if(file==NULL)
	printf("il file non c'");



//Lettura delle dimensioni
fscanf(file, "%d",&GS.NumRow);
fscanf(file, "%d",&GS.NumCol);

//Alloco array costi
GS.ArrayCosti=(float *)malloc(sizeof(float)*GS.NumCol);



//Lettura array dei costi
for(i=0;i<GS.NumCol;++i)
{
	fscanf(file, "%d",&tmp);
	GS.ArrayCosti[i]=(float)tmp;
}

//Alloco la stuttura contenete il numero di uno per riga
GS.NumUnoPerRow=(int*)malloc(sizeof(int)* (GS).NumRow);

//Lettura array di liste inidici coperti
GS.PosUnoPerRow=(int **)malloc(sizeof(int*)*GS.NumRow );

//Creazione matrice zero uni
GS.MatrixZeroOne=(int **)malloc(sizeof(int*)*GS.NumRow );

GS.rowList=(int *)malloc(sizeof(int)* GS.NumRow);

for(i=0;i<GS.NumRow;++i)
{
	
	
	//Leggo il numero di variabili settate a uno sulla riga i-esima
	fscanf(file, "%d",&NumeroUni);
	GS.PosUnoPerRow[i]=(int *)malloc(sizeof(int)* NumeroUni);

	//Alloco la riga della matrice di zero e uni
	GS.MatrixZeroOne[i]=(int *)malloc(sizeof(int)* GS.NumCol);
	
	//inizializzo la amtrice di zero e un
	for(j=0;j<GS.NumCol;++j)
		GS.MatrixZeroOne[i][j]=0;

	

    //Mantengo il numero di uno in una struttura a parte
	GS.NumUnoPerRow[i]=NumeroUni;
	
	//Setto gli uni della riga i-esima
	for(j=0;j<NumeroUni;++j)
	{
		
		fscanf(file, "%d",&PosUno);
		PosUno--;
		GS.PosUnoPerRow[i][j]=PosUno;
		GS.MatrixZeroOne[i][PosUno]=1;
		
	}
	
}


for(i=0;i<GS.NumRow;++i)
{
	//GS.Penalties[i]=0.0;
	GS.rowList[i]=i;
}
GS.colList=(int *)malloc(sizeof(int)* GS.NumCol);

GS.NumUnoPerCol=(int *)malloc(sizeof(int)* GS.NumCol);
GS.PosUnoPerCol=(int **)malloc(sizeof(int*)* GS.NumCol);
GS.LB.SensAnalFC.IsFixed=(int *)malloc(sizeof(int)* GS.NumCol);
GS.LB.SensAnalFC.Value=(int *)malloc(sizeof(int)* GS.NumCol);

//Geneero un lista delle colonne
//La lista degli uno pe colonna 
for(i=0;i<GS.NumCol;++i)
{

		GS.colList[i]=i;
		GS.NumUnoPerCol[i]=0;
		GS.PosUnoPerCol[i]=(int *)malloc(sizeof(int)* GS.NumRow);
		GS.LB.SensAnalFC.IsFixed[i]=FALSE;
		GS.LB.SensAnalFC.Value[i]=0;
		for(j=0;j<GS.NumRow;++j)
		{
			if(GS.MatrixZeroOne[j][i])
			{
				GS.PosUnoPerCol[i][GS.NumUnoPerCol[i]]=j;
				GS.NumUnoPerCol[i]++;
			}
		}
}
//Subgradienti e lagragiani
GS.LB.SubGradienti.Values=(float *)malloc(sizeof(float )*GS.NumRow);
GS.LB.SubGradienti.size=GS.NumRow;

GS.LB.Penalties.Values=(float *)malloc(sizeof(float )*GS.NumRow);
GS.LB.Penalties.size=GS.NumRow;

GS.LB.CostoRidotti.Values=malloc(sizeof(float )*GS.NumCol);
GS.LB.CostoRidotti.size=GS.NumCol;

GS.LB.ColsNotInSol.Values=malloc(sizeof(int)*GS.NumCol);
GS.LB.ColsNotInSol.size=0;


GS.LB.LBSolutionTmpIndexList.Values=malloc(sizeof(int)*GS.NumCol);
GS.LB.LBSolutionTmpIndexList.size=0;

GS.LB.LBSolutionTmpIndexList2.Values=malloc(sizeof(int)*GS.NumCol);
GS.LB.LBSolutionTmpIndexList2.size=0;


GS.LB.TempRowList.Values=(int*)malloc(sizeof(int)*GS.NumRow);
memcpy(GS.LB.TempRowList.Values,GS.rowList,sizeof(int)*(GS.NumRow));
GS.LB.TempRowList.size=GS.NumRow;

GS.LB.TempColList.Values=(int*)malloc(sizeof(int)*GS.NumCol);
memcpy(GS.LB.TempColList.Values,GS.colList,sizeof(int)*(GS.NumCol));
GS.LB.TempColList.size=GS.NumCol;


GS.LB.FixedRow.Values=(int*)malloc(sizeof(int)*GS.NumRow);
GS.LB.FixedRow.size=GS.NumRow;
fclose(file);


}


void ControllaDati()
{
int i,j;

printf("Array dei costi :\n");
for(i=0;i<GS.NumCol;++i)
	printf("%f\t",GS.ArrayCosti[i]);


printf("\nMatrice zero uno:\n");
for(j=0;j<GS.NumRow;++j)
{
	for(i=0;i<GS.NumCol;++i)
		printf("%d ",GS.MatrixZeroOne[j][i]);

	printf("\n");
}
getchar();
printf("\nNumero uni per riga\n");
for(j=0;j<GS.NumRow;++j)
{
	printf("%d\t",GS.NumUnoPerRow[j]);
	

}
getchar();
printf("\nMatrice NumUno per Row:\n");
for(i=0;i<GS.NumRow;++i)
{
	for(j=0;j<GS.NumUnoPerRow[i];++j)
		printf("%d ",GS.PosUnoPerRow[i][j]);

	printf("\n");
}
//getchar();
printf("\nMatrice NumUno per Col:\n");
for(i=0;i<GS.NumCol;++i)
{
	for(j=0;j<GS.NumUnoPerCol[i];++j)
		printf("%d ",GS.PosUnoPerCol[i][j]);

	printf("\n");
}//getchar();
printf("\nLe colonne sono :\n");
for(i=0;i<GS.NumCol;++i)
	printf("%d",GS.colList[i]);
	
//getchar();
	printf("\nLe righe sono :\n");
for(i=0;i<GS.NumRow;++i)
	printf("%d",GS.rowList[i]);

//getchar();
}
void RandomGen(int ncol, int nrow,int maxcost)
{

int i,j,k;

//Numero di uni su di una riga
int NumeroUni=0;

//Posizione uno
int PosUno=0;
float prove;
GS.NumCol=ncol;
GS.NumRow=nrow;

//Alloco array costi
GS.ArrayCosti=(float *)malloc(sizeof(float)*GS.NumCol);



//Lettura array dei costi
for(i=0;i<GS.NumCol;++i)
{
	prove=((float)maxcost)*(rand() /(float) RAND_MAX );
	
	k=(int)prove;
	if(k==0)
		k=1;
	GS.ArrayCosti[i]=k;
}

//Alloco la stuttura contenete il numero di uno per riga
GS.NumUnoPerRow=(int*)malloc(sizeof(int)* (GS).NumRow);

//Lettura array di liste inidici coperti
GS.PosUnoPerRow=(int **)malloc(sizeof(int*)*GS.NumRow );

//Creazione matrice zero uni
GS.MatrixZeroOne=(int **)malloc(sizeof(int*)*GS.NumRow );

GS.rowList=(int *)malloc(sizeof(int)* GS.NumRow);




for(i=0;i<GS.NumRow;++i)
{
	
	
	//Leggo il numero di variabili settate a uno sulla riga i-esima
	NumeroUni=(int)(ncol*((float )rand()/(float )RAND_MAX));
	if(NumeroUni==0)
		NumeroUni++;
	GS.PosUnoPerRow[i]=(int *)malloc(sizeof(int)* NumeroUni);

	//Alloco la riga della matrice di zero e uni
	GS.MatrixZeroOne[i]=(int *)malloc(sizeof(int)* GS.NumCol);
	
	
	for(j=0;j<GS.NumCol;++j)
		GS.MatrixZeroOne[i][j]=0;



    //Mantengo il numero di uno in una struttura a parte
	GS.NumUnoPerRow[i]=NumeroUni;
	
	//Setto gli uni della riga i-esima
	for(j=0;j<NumeroUni;++j)
	{

		do
		{
			prove=((float)GS.NumCol)*(rand() /(float) RAND_MAX );
			k=(int)prove;
			PosUno=k;

			if(PosUno==GS.NumCol)
			{
				PosUno--;
			}
			if(PosUno<0 || PosUno>(GS.NumCol-1))
			{
				printf("c' un errore");
					getchar();
			}
		}
		while(GS.MatrixZeroOne[i][PosUno]==1);

		GS.PosUnoPerRow[i][j]=PosUno;
		GS.MatrixZeroOne[i][PosUno]=1;
		
		
		

	}
	
}


for(i=0;i<GS.NumRow;++i)
{
	//GS.Penalties[i]=0.0;
	GS.rowList[i]=i;
}
GS.colList=(int *)malloc(sizeof(int)* GS.NumCol);
GS.NumUnoPerCol=(int *)malloc(sizeof(int)* GS.NumCol);
GS.PosUnoPerCol=(int **)malloc(sizeof(int*)* GS.NumCol);
//Geneero un lista delle colonne
//La lista degli uno pe colonna 
for(i=0;i<GS.NumCol;++i)
{
		GS.colList[i]=i;
		GS.NumUnoPerCol[i]=0;
		GS.PosUnoPerCol[i]=(int *)malloc(sizeof(int)* GS.NumRow);


		for(j=0;j<GS.NumRow;++j)
		{
			if(GS.MatrixZeroOne[j][i]==1)
			{
				GS.PosUnoPerCol[i][GS.NumUnoPerCol[i]]=j;
				GS.NumUnoPerCol[i]++;
			}
		}
	
		
}

//Subgradienti e lagragiani
GS.LB.SubGradienti.Values=malloc(sizeof(float )*GS.NumRow);
GS.LB.SubGradienti.size=GS.NumRow;

GS.LB.Penalties.Values=malloc(sizeof(float )*GS.NumRow);
GS.LB.Penalties.size=GS.NumRow;

GS.LB.CostoRidotti.Values=malloc(sizeof(float )*GS.NumCol);
GS.LB.CostoRidotti.size=GS.NumCol;

GS.LB.ColsNotInSol.Values=malloc(sizeof(int)*GS.NumCol);
GS.LB.ColsNotInSol.size=0;




GS.LB.LBSolutionTmpIndexList.Values=malloc(sizeof(int)*GS.NumCol);
GS.LB.LBSolutionTmpIndexList.size=0;

GS.LB.LBSolutionTmpIndexList2.Values=malloc(sizeof(int)*GS.NumCol);
GS.LB.LBSolutionTmpIndexList2.size=0;


GS.LB.TempRowList.Values=(int*)malloc(sizeof(int)*GS.NumRow);
memcpy(GS.LB.TempRowList.Values,GS.rowList,sizeof(int)*(GS.NumRow));
GS.LB.TempRowList.size=GS.NumRow;

GS.LB.TempColList.Values=(int*)malloc(sizeof(int)*GS.NumCol);
memcpy(GS.LB.TempColList.Values,GS.colList,sizeof(int)*(GS.NumCol));
GS.LB.TempColList.size=GS.NumCol;

}
void DeleteGS()
{
	int i;
	free(GS.ArrayCosti);
	free(GS.colList);
	for(i=0;i<GS.NumRow;++i)
		free(GS.MatrixZeroOne[i]);

	free(GS.MatrixZeroOne);
	
	for(i=0;i<GS.NumCol;++i)
		free(GS.PosUnoPerCol[i]);

	for(i=0;i<GS.NumRow;++i)
		free(GS.PosUnoPerRow[i]);

	free(GS.NumUnoPerCol);

	
	free(GS.NumUnoPerRow);

	free(GS.LB.ColsNotInSol.Values);
	free(GS.LB.CostoRidotti.Values);
	free(GS.LB.LBSolutionTmpIndexList.Values);
	free(GS.LB.LBSolutionTmpIndexList2.Values);
	free(GS.LB.Penalties.Values);
	free(GS.LB.SubGradienti.Values);
	free(GS.LB.TempColList.Values);
	free(GS.LB.TempRowList.Values);
	free(GS.LB.SensAnalFC.IsFixed);
	free(GS.LB.SensAnalFC.Value);
	free(GS.LB.FixedRow.Values);
}

void provatempo()
{
	 int count,a;
LARGE_INTEGER ticksPerSecond;
LARGE_INTEGER tick;   // A point in time
LARGE_INTEGER start_ticks, end_ticks, cputime;   

 printf ("\ Value of CLOCKS_PER_SEC is :    %f  ticks/sec\n",CLOCKS_PER_SEC   );

 // get the high resolution counter's accuracy
  if (!QueryPerformanceFrequency(&ticksPerSecond))
 printf("\tno go QueryPerformance not present");
printf ("\tfreq test:   %I64Ld ticks/sec\n",ticksPerSecond    );
 // what time is it?
  if (!QueryPerformanceCounter(&tick) ) printf("no go counter not installed");  
printf ("\QueryPerformanceCounter testpoint :   %I64Ld  ticks\n",tick);

QueryPerformanceCounter(&start_ticks); 
  /* start foo()  */ 
 
 
  /* end foo( ) */
 
QueryPerformanceCounter(&end_ticks); 
cputime.QuadPart = end_ticks.QuadPart- start_ticks.QuadPart;

printf ("\tElapsed CPU time test:   %.9f  sec  ticks %d\n",
((float)cputime.QuadPart/(float)ticksPerSecond.QuadPart),cputime.QuadPart);
return 0;
}

	
